--- linux-4.14.0-115.2.2.el7a-pristine/lib/rhashtable.c  2018-11-05 10:09:18.000000000 -0700
+++ linux-4.14.0-115.2.2.el7a-modified/lib/rhashtable.c  2019-01-02 09:45:03.215889179 -0700
@@ -463,6 +463,12 @@
 
      mutex_unlock(&ht->mutex);
 
+     if (err == -EEXIST) {
+           printk("[SNLDBG cpu=%d] returning early to avoid kworker bug/hang (ht=%lx, err=%d)\n",
+                 smp_processor_id(), (unsigned long)ht, err);
+           return;
+     }
+
      if (err)
            schedule_work(&ht->run_work);
 }